<?php

header("Cache-Control: no-cache, must-revalidate");
header("Expires: Sat, 26 Jul 1997 05:00:00 GMT");

$INC_DIR = $_SERVER["DOCUMENT_ROOT"] . "geoip-api/";

include($INC_DIR . "geoip.inc");
include($INC_DIR . "geoipcity.inc");
include($INC_DIR . "geoipregionvars.php");

$gi4 = geoip_open($INC_DIR . "GeoIP.dat",GEOIP_STANDARD);
$gi6 = geoip_open($INC_DIR . "GeoIPv6.dat",GEOIP_STANDARD);
$gicity4 = geoip_open($INC_DIR . "GeoLiteCity.dat",GEOIP_STANDARD);
$gicity6 = geoip_open($INC_DIR . "GeoLiteCityv6.dat",GEOIP_STANDARD);

$IpAddr = $_SERVER["REMOTE_ADDR"];

$osList = array
(
	'Windows 7' => 'windows nt 6.1',
	'Windows Vista' => 'windows nt 6.0',
	'Windows Server 2003' => 'windows nt 5.2',
	'Windows XP' => 'windows nt 5.1',
	'Windows 2000 sp1' => 'windows nt 5.01',
	'Windows 2000' => 'windows nt 5.0',
	'Windows NT 4.0' => 'windows nt 4.0',
	'Windows Me' => 'win 9x 4.9',
	'Windows 98' => 'windows 98',
	'Windows 95' => 'windows 95',
	'Windows CE' => 'windows ce',
	'Windows (version unknown)' => 'windows',
	'OpenBSD' => 'openbsd',
	'SunOS' => 'sunos',
	'Ubuntu' => 'ubuntu',
	'Linux' => '(linux)|(x11)',
	'Mac OSX Beta (Kodiak)' => 'mac os x beta',
	'Mac OSX Cheetah' => 'mac os x 10.0',
	'Mac OSX Puma' => 'mac os x 10.1',
	'Mac OSX Jaguar' => 'mac os x 10.2',
	'Mac OSX Panther' => 'mac os x 10.3',
	'Mac OSX Tiger' => 'mac os x 10.4',
	'Mac OSX Leopard' => 'mac os x 10.5',
	'Mac OSX Snow Leopard' => 'mac os x 10.6',
	'Mac OSX Lion' => 'mac os x 10.7',
	'Mac OSX (version unknown)' => 'mac os x',
	'Mac OS (classic)' => '(mac_powerpc)|(macintosh)',
	'QNX' => 'QNX',
	'BeOS' => 'beos',
	'OS2' => 'os/2',
	'SearchBot'=>'(nuhk)|(googlebot)|(yammybot)|(openbot)|(slurp)|(msnbot)|(ask jeeves/teoma)|(ia_archiver)'
);

$useragent = $_SERVER['HTTP_USER_AGENT'];
$useragent = strtolower($useragent);
$browser = getBrowser();
 
if(ipVersion($IpAddr) == 4) {
 	$country = geoip_country_name_by_addr($gi4, $IpAddr);
 	$cc = geoip_country_code_by_addr($gi4, $IpAddr);
	$record = geoip_record_by_addr($gicity4, $IpAddr);
 	$region = $GEOIP_REGION_NAME[$record->country_code][$record->region];
 	$flag = $_SERVER["DOCUMENT_ROOT"] . "flags/" . strtolower($cc) . ".png";
} else {
        $country = geoip_country_name_by_addr_v6($gi6, $IpAddr);
        $cc = geoip_country_code_by_addr_v6($gi6, $IpAddr);
	$record = geoip_record_by_addr_v6($gicity6, $IpAddr);
        $region = $GEOIP_REGION_NAME[$record->country_code][$record->region];
        $flag = $_SERVER["DOCUMENT_ROOT"] . "flags/"  . strtolower($cc) . ".png";
}

foreach($osList as $os=>$match) {
 	if (preg_match('/' . $match . '/i', $useragent)) {
 		break; 
 	} else {
 		$os = "Undefined"; 
 	}

}


create_badge($country, $cc, $region, $flag, $os, $browser['name'], $IpAddr, $proxy);

function create_badge($f_country, $f_cc, $f_region, $f_flag, $f_os, $f_browser, $f_ipaddr, $f_proxy)
{
	
	//$font_width = imagefontwidth(3);
	//$width =  $font_width * strlen($_SERVER['REMOTE_ADDR']) + 25;
	$width = 220;
	$height = 100;

	$badge_flag = imagecreatefrompng($f_flag);

	$image = ImageCreate($width, $height);

	$white = ImageColorAllocate($image, 255, 255, 255);
	$black = ImageColorAllocate($image, 0, 0, 0);
	$grey = ImageColorAllocate($image, 192, 192, 192);

	ImageFill($image, 0, 0, $grey);

	ImageString($image, 3, 5, 5,  "Country      : $f_country", $white);
	ImageString($image, 3, 5, 17, "Country Code : $f_cc", $white);
	ImageString($image, 3, 5, 29, "Region       : $f_region", $white);
	ImageString($image, 3, 5, 43, "Flag         : ", $white);
	Imagecopymerge($image, $badge_flag, 110, 45, 0, 0, 20, 11, 100);
	ImageString($image, 3, 5, 55, "OS           : $f_os", $white);
	ImageString($image, 3, 5, 67, "Browser      : $f_browser", $white);
	ImageString($image, 3, 5, 79, "IP           : $f_ipaddr", $white);

	header("Content-Type: image/jpeg");
	ImageJpeg($image);
	ImageDestroy($image);
}

function getBrowser()
{
	$u_agent = $_SERVER['HTTP_USER_AGENT'];
	$bname = 'Unknown';
	$platform = 'Unknown';

	//First get the platform?
	if (preg_match('/linux/i', $u_agent)) {
		$platform = 'linux';
	}
	elseif (preg_match('/macintosh|mac os x/i', $u_agent)) {
		$platform = 'mac';
	}
	elseif (preg_match('/windows|win32/i', $u_agent)) {
		$platform = 'windows';
	}

	// Next get the name of the useragent yes seperately and for good reason
	if(preg_match('/MSIE/i',$u_agent) && !preg_match('/Opera/i',$u_agent))
	{
		$bname = 'Internet Explorer';
		$ub = "MSIE";
	}
	elseif(preg_match('/Firefox/i',$u_agent))
	{
		$bname = 'Mozilla Firefox';
		$ub = "Firefox";
	}
	elseif(preg_match('/Chrome/i',$u_agent))
	{
		$bname = 'Google Chrome';
		$ub = "Chrome";
	}
	elseif(preg_match('/Safari/i',$u_agent))
	{
		$bname = 'Apple Safari';
		$ub = "Safari";
	}
	elseif(preg_match('/Opera/i',$u_agent))
	{
		$bname = 'Opera';
		$ub = "Opera";
	}
	elseif(preg_match('/Netscape/i',$u_agent))
	{
		$bname = 'Netscape';
		$ub = "Netscape";
	}

	return array(
		'userAgent' => $u_agent,
		'name'      => $bname,
		'version'   => $version,
		'platform'  => $platform,
	);
}

function ipVersion($ipvar) {
	return strpos($ipvar, ":") === false ? 4 : 6;
}

geoip_close($gi4);
geoip_close($gi6);
geoip_close($gicity4);
geoip_close($gicity6);

?>
